// $Id: kwresearch.js,v 1.1.2.1 2010/06/03 22:20:20 tomdude48 Exp $

/*
if (Drupal.jsEnabled) {
  $(document).ready(function () {
    //kwresearch_init();
  });
}
*/
Drupal.behaviors.kwresearch_init = function (context) {
  kwresearch_init();
}

var kwresearch_init = function () {
  kwresearch_process_keywords();
}

var kwresearch_get_keyword_list = function(type) {
  var value = '';
  var keywords = new Array();
  
  if(type == 'vocab') {
    if(Drupal.settings.kwresearch.keyword_vocabulary) {    
      if($('#edit-taxonomy-tags-' + Drupal.settings.kwresearch.keyword_vocabulary).val() != null) {
        value = $('#edit-taxonomy-tags-' + Drupal.settings.kwresearch.keyword_vocabulary).val();
      } 
    }    
  }
  else if(type == 'mlt') {
    if($('#edit-morelikethis-terms').val() != null) {
      value = $('#edit-morelikethis-terms').val();  
    }
  }
  else if(type == 'meta_keywords') {
    if($('#edit-nodewords-keywords-value').val() != null) {
      value = $('#edit-nodewords-keywords-value').val();
    }
  }
  
  keywords = value.split(',');  
  for(var i in keywords) {
    keywords[i] = jQuery.trim(keywords[i].toLowerCase());
  }
  return keywords;
}

// Implementation of hook_contentanalysis_analysis_success
var kwresearch_contentanalysis_analysis_success = function() {	
  kwresearch_init();	
}

var kwresearch_in_array = function(needle, haystack) {
	for(var i = 0; i < haystack.length; i++) {
		if(haystack[i] == needle) {
			return true;
		}
	}
	return false;
}


var kwresearch_process_keywords = function() {
  $('.kwresearch_keyword:not(.processed)').each( function(index) {
    keyword = $(this).text().toLowerCase();
    str = kwresearch_get_buttons(keyword);
    
    $(this).addClass('processed');
    $(this).append(str);
    $('.kwresearch_actions').hide();
    $(this).mouseover( function() {
      $(this).addClass('active');
      var tools = $(this).find('.kwresearch_actions');
      var pos = $(this).position(); 
      var left = pos.left; 
      var top = pos.top;
      var topOffset = $(this).height();
      var xTip = (left-0)+"px";  
      //var yTip = (0-topOffset+top)+"px";  
      var yTip = (0+top)+"px";  
      tools.css({'top' : yTip, 'left' : xTip});  
      tools.show();
      
    });
    $(this).mouseout( function() {
      var tools = $(this).find('.kwresearch_actions');
      $(this).removeClass('active');
      tools.hide();
    });
  });
}

var kwresearch_get_buttons = function(keyword) {
    str = '<div class="kwresearch_actions">';
    title = Drupal.t('Keyword report');
    str += '<a href="#" onclick="kwresearch_launch_report(\'' + keyword + '\'); return false;" title="' + title + '" class="kwresearch-tool-button">';
    str += '<img src="' + Drupal.settings.kwresearch.module_path + '/icons/report.png" title="' + title + '" />';
    str += '</a>';

    str += kwresearch_get_toggle_button(keyword, 'vocab');
    str += kwresearch_get_toggle_button(keyword, 'mlt');
    str += kwresearch_get_toggle_button(keyword, 'meta_keywords');

    str += '</div>';
    return str;
}

var kwresearch_get_toggle_button = function(keyword, type) {
  var str = '';
  var keyword_list = kwresearch_get_keyword_list(type);
  if(type == 'vocab') {
    if(Drupal.settings.kwresearch.keyword_vocabulary 
      && ($('#edit-taxonomy-tags-' + Drupal.settings.kwresearch.keyword_vocabulary).size() > 0)) {
      add = 1;
      img = 'add';
      title = Drupal.t('Add keyword to keyword vocabulary');
      
      if(kwresearch_in_array(keyword, keyword_list)) {
        add = 0;
        img = 'delete'
        title = Drupal.t('Remove keyword from keyword vocabulary');
      }
      keyword
      str += '<a href="#" onclick="kwresearch_toggle_vocab_keyword(\'' + keyword + '\', ' + add + ', this); return false;" title="' + title + '" class="kwresearch-tool-button">';
      str += '<img src="' + Drupal.settings.kwresearch.module_path + '/icons/vocab_' + img + '.png" title="' + title + '" />';
      str += '</a>';       
    }
  }
  else if(type == 'mlt') {  
    if($('#edit-morelikethis-terms').size() > 0) {
      add = 1;
      img = 'add';
      title = Drupal.t('Add keyword to More Like This');
      if(kwresearch_in_array(keyword, keyword_list)) {
        add = 0;
        img = 'delete'
        title = Drupal.t('Remove keyword from More Like This');
      }
      str += '<a href="#" onclick="kwresearch_toggle_mlt_keyword(\'' + keyword + '\', ' + add + ', this); return false;" title="' + title + '" class="kwresearch-tool-button">';
      str += '<img src="' + Drupal.settings.kwresearch.module_path + '/icons/mlt_' + img + '.png" title="' + title + '" />';
      str += '</a>';
    }
  }
  else if(type == 'meta_keywords') {  
    if($('#edit-nodewords-keywords-value').size() > 0) {
      add = 1;
      img = 'add';
      title = Drupal.t('Add keyword to meta keywords');
      if(kwresearch_in_array(keyword, keyword_list)) {
        add = 0;
        img = 'delete'
        title = Drupal.t('Remove keyword to meta keywords');
      }
      str += '<a href="#" onclick="kwresearch_toggle_meta_keyword(\'' + keyword + '\', ' + add + ', this); return false;" title="' + title + '" class="kwresearch-tool-button">';
      str += '<img src="' + Drupal.settings.kwresearch.module_path + '/icons/metakeywords_' + img + '.png" title="' + title + '" />';
      str += '</a>';
    }
  }
  return str
}

var kwresearch_launch_report = function(keyword) {
  //alert(keyword);
  $('#edit-kwresearch-keyword').val(keyword);
  contentanalysis_show_analyzer_tab(document.getElementById('contentanalysis-analyzer-tab-kwresearch'));
  kwresearch_analyze();
  return false;
}

var kwresearch_toggle_vocab_keyword = function(keyword, add, theLink) {
  v = $('#edit-taxonomy-tags-' + Drupal.settings.kwresearch.keyword_vocabulary).val();
  if(add) {    
    nv = v + (v ? ', ' : '') + keyword;    
  }
  else {
    nv = kwresearch_remove_phrase_from_list(keyword, v);
  }
  $('#edit-taxonomy-tags-' + Drupal.settings.kwresearch.keyword_vocabulary).val(nv);
  $(theLink).replaceWith(kwresearch_get_toggle_button(keyword, 'vocab'));
  return false;
}

var kwresearch_toggle_mlt_keyword = function(keyword, add, theLink) {
  v = $('#edit-morelikethis-terms').val();
  if(add) {    
    nv = v + (v ? ', ' : '') + keyword;    
  }
  else {
    nv = kwresearch_remove_phrase_from_list(keyword, v);
  }
  $('#edit-morelikethis-terms').val(nv);
  $(theLink).replaceWith(kwresearch_get_toggle_button(keyword, 'mlt'));
  return false;
}

var kwresearch_toggle_meta_keyword = function(keyword, add, theLink) {
  v = $('#edit-nodewords-keywords-value').val();
  if(add) {    
    nv = v + (v ? ', ' : '') + keyword;    
  }
  else {
    nv = kwresearch_remove_phrase_from_list(keyword, v);
  }
  $('#edit-nodewords-keywords-value').val(nv);
  $(theLink).replaceWith(kwresearch_get_toggle_button(keyword, 'meta_keywords'));
  return false;
}

var kwresearch_remove_phrase_from_list = function(keyword, list) {
  kws0 = list.split(',');  
  kws1 = new Array();
  j = 0;
  for(var i in kws0) {    
    k = jQuery.trim(kws0[i].toLowerCase());
    if(k != keyword) {
      kws1[j] = k;
      j++;
    }    
  }  
  return kws1.join(', ');
}

var kwresearch_analyze = function() {
  // if TinyMCE is used, turn off and on to save body text to textarea
 
  var data = { 
    'kwresearch_keyword': '',
    'kwresearch_include_misspellings': 0,
    'kwresearch_include_plurals': 0,
    'kwresearch_adult_filter':$('#edit-kwresearch-adult-filter:selected').val()
  };
  data.kwresearch_keyword = $('#edit-kwresearch-keyword').val();
  if($('#edit-kwresearch-include-misspellings:checked').val() != null) {
    data.kwresearch_include_misspellings = 1;
  }
  if($('#edit-kwresearch-include-plurals:checked').val() != null) {
    data.kwresearch_include_plurals = 1;
  }
  
  $('.kwresearch-result-block').hide();
  var id = 'kwresearch-result-block-' + data.kwresearch_keyword.replace(' ', '-').toLowerCase();
  var existing = $('#' + id);
  if(existing.size() > 0) {
    $(existing).show();
  } else {
    $('#kwresearch-submit-button').after('<div class="ahah-progress ahah-progress-throbber"><div class="throbber">&nbsp;</div><div class="message">' + Drupal.t('Analyzing...') + '</div></div>');
    $('#kwresearch-submit-button').hide();  
    $.ajax({
      type: 'POST',
      url: Drupal.settings.kwresearch.analyze_callback,
      data: data,
      dataType: 'json',
      success: function(data, textStatus) {
        $('#kwresearch-report').append(data.report['output']);
        kwresearch_init();
        $('.ahah-progress-throbber').remove();
        $('#kwresearch-submit-button').show();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        //alert("error " + XMLHttpRequest.toString());
        $('.ahah-progress-throbber').remove();
        $('#kwresearch-submit-button').show();
      }
    });
  }
  return false;	
}